.386

.model flat, stdcall 
option casemap :none 

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\winmm.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\winmm.lib

.data

.data?
MixerLine		MIXERLINE <>
MixerControl		MIXERCONTROL <>
MixerLineControls	MIXERLINECONTROLS <>
MixerControlDetails	MIXERCONTROLDETAILS <>
MixerControlDetails_U	MIXERCONTROLDETAILS_UNSIGNED <> 
hMixer			DWORD ?
LineID			DWORD ?
ControlID		DWORD ?
BassValue		DWORD ?
string			db ?
.code
start:
	invoke mixerOpen, addr hMixer, 0, NULL, NULL, NULL   ; Open preferred Mixer Device (ID = 0)
	mov eax, SIZEOF MIXERLINE
	mov MixerLine.cbStruct, eax
	mov eax, MIXER_GETLINEINFOF_LINEID;MIXERLINE_COMPONENTTYPE_DST_SPEAKERS		; Set device to work with here
	mov MixerLine.dwComponentType, eax
	invoke mixerGetLineInfo, hMixer, addr MixerLine, MIXER_GETLINEINFOF_LINEID;MIXER_GETLINEINFOF_COMPONENTTYPE
	.if eax
		invoke MessageBox,0,0,0,0
	.endif
	mov eax, MixerLine.dwLineID
	mov LineID, eax
	; *** Set Volume Control ***
	mov eax, SIZEOF MIXERLINECONTROLS 
	mov MixerLineControls.cbStruct, eax
	mov eax, LineID
	mov MixerLineControls.dwLineID, eax
	mov MixerLineControls.cControls, 1
	mov eax, MIXERCONTROL_CONTROLTYPE_VOLUME		; Volume control
	mov MixerLineControls.dwControlType, eax
	mov eax, OFFSET MixerControl
	mov MixerLineControls.pamxctrl, eax
	mov eax, SIZEOF MIXERCONTROL
	mov MixerLineControls.cbmxctrl, eax 
	invoke mixerGetLineControls, hMixer, addr MixerLineControls, MIXER_GETLINECONTROLSF_ONEBYTYPE
	.if eax
		invoke MessageBox,0,0,0,0
	.endif
	mov eax, MixerControl.dwControlID       
	mov ControlID, eax
	mov eax, SIZEOF MIXERCONTROLDETAILS
	mov MixerControlDetails.cbStruct, eax
	mov eax, ControlID 
	mov MixerControlDetails.dwControlID, eax
	mov MixerControlDetails.cChannels, 1
	mov MixerControlDetails.cMultipleItems, 0
	mov eax, OFFSET MixerControlDetails_U
	mov MixerControlDetails.paDetails, eax
	mov eax, SIZEOF MIXERCONTROLDETAILS_UNSIGNED
	mov MixerControlDetails.cbDetails, eax
	invoke mixerGetControlDetails, hMixer, addr MixerControlDetails, MIXER_GETCONTROLDETAILSF_VALUE
	.if eax
		invoke MessageBox,0,0,0,0
	.endif
	mov eax, MixerControlDetails_U.dwValue
	mov BassValue, eax
	mov eax, SIZEOF MIXERCONTROLDETAILS
	mov MixerControlDetails.cbStruct, eax
	mov eax, ControlID
	mov MixerControlDetails.dwControlID, eax
	mov MixerControlDetails.cChannels, 1
	mov MixerControlDetails.cMultipleItems, 0
	mov eax, OFFSET MixerControlDetails_U
	mov MixerControlDetails.paDetails, eax
	mov eax, SIZEOF MIXERCONTROLDETAILS_UNSIGNED
	mov MixerControlDetails.cbDetails, eax
	.if MixerControlDetails_U.dwValue==0
		mov MixerControlDetails_U.dwValue,65535	; SET THE SPEAKER VOLUME -- Volume is from 0 -> 65535(Max Volume)
	.else
		mov MixerControlDetails_U.dwValue,0
	.endif
	invoke mixerSetControlDetails, hMixer, addr MixerControlDetails, MIXER_SETCONTROLDETAILSF_VALUE
	.if eax
		invoke MessageBox,0,0,0,0
	.endif
	invoke mixerClose, hMixer
	invoke ExitProcess,0
end start


